/**
  ******************************************************************************
  * @file    vk1640_driver.c
  * @author  kevin_guo
  * @version V1.0.0
  * @date    072-01-2019
  * @brief   This file contains all files for vk1640_driver.
  ******************************************************************************
  * @attention
  ******************************************************************************
  */
/* Includes ------------------------------------------------------------------*/
#include "vk1640_driver.h"

/* extern variables ----------------------------------------------------------*/
//extern uint8_t ic_key;
/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
unsigned char vk1640_write_buf[16];
/* Private function prototypes -----------------------------------------------*/
/* Private function ----------------------------------------------------------*/

/*******************************************************************************
* Function Name  : VK1640_delay_nus
* Description    : ʱ1uS
* Input          : n->ʱʱnuS
* Output         : None
* Return         : None
*******************************************************************************/
void VK1640_delay_nus(unsigned int n)	   
{
	unsigned char i;
	while(n--)
	{
		i=10;
		while(i--)
		{//nopָݵƬӦ޸
			__nop();
		}
	}
}	
/*******************************************************************************
* Function Name  : VK1640_delay_nms
* Description    : ʱ1mS
* Input          : n->ʱʱnmS
* Output         : None
* Return         : None
*******************************************************************************/
void VK1640_delay_nms(unsigned long int n)
{
	while(n--)
	{
		VK1640_delay_nus(1000);
	}
}
/*******************************************************************************
* Function Name  : VK1640_Start
* Description    : VK1640ʼź
* Input          : None 
* Output         : None
* Return         : None
*******************************************************************************/
void VK1640_Start(void)
{
	VK1640_DAT_HIGH;//ͨѶʼǰͨѶ˿ȫʼΪ1	
	VK1640_SLK_HIGH;
	VK1640_delay_nus(2);
	VK1640_DAT_LOW;
	VK1640_SLK_LOW;
	VK1640_delay_nus(1);
}
/*******************************************************************************
* Function Name  : VK1640_Stop
* Description    : VK1640ֹͣź
* Input          : None 
* Output         : None
* Return         : None
*******************************************************************************/
void VK1640_Stop(void)
{
	VK1640_SLK_LOW;
	VK1640_delay_nus(1);
	VK1640_DAT_LOW;
	VK1640_SLK_HIGH;
	VK1640_delay_nus(2);
	VK1640_DAT_HIGH;
	VK1640_delay_nus(1);
}
/*******************************************************************************
* Function Name  : VK1640Write1BytetoIC
* Description    : ʱӵͨMCULEDICд1ֽ
* Input          : data8
* Output         : None
* Return         : None
*******************************************************************************/
void VK1640Write1BytetoIC(unsigned char data8)
{
	uint8_t i;
	
	for(i=0;i<8;i++)
	{
		VK1640_SLK_LOW;		//ȽCLK
		if((data8&0x01)!=0)
		{
			VK1640_DAT_HIGH;//Ҫ͵ݵĵλΪ1ѡDIOø
		}
		else
		{
			VK1640_DAT_LOW;	//Ҫ͵ݵĵλΪ0ѡDIO
		}
		VK1640_delay_nus(2);
		VK1640_SLK_HIGH;	//ʱӵ
		VK1640_delay_nus(2);
		data8=data8>>1;		//׼һBIT
	
	}//һֽں˳ѭ

}


/*******************************************************************************
* Function Name  : Disp_AutoAdd1Addr
* Description    : õַԶһʽַ
* Input          : cmdaddr   дĵַ
*					 			 : databuf   ݻ
*                : num       дݸ
* Output         : None
* Return         : None
*******************************************************************************/
void VK1640_Disp_AutoAdd1Addr(unsigned char addr,unsigned char *databuf, unsigned char num)
{
	unsigned char	 i;//iƱҪٸֽʾ	
	
	VK1640_Start();
	VK1640Write1BytetoIC(VK1640_WRDTA_AUTOADD1ADDR);//òõַԶ1ʽдʾݣ
	VK1640_Stop();
	VK1640_Start();	
	VK1640Write1BytetoIC(VK1640_STARTADDR+addr);//ʼַ
	//ַ󣬡STBΪ0Ҫʾ
	for(i=0;i<num;i++)
	{
		VK1640Write1BytetoIC(*databuf++);//ʾݹУSTBһֱΪ0
	}
	VK1640_Stop();
	VK1640_Start();	
	VK1640Write1BytetoIC(VK1640_DISP_ON|VK1640_PDUTY_14_16);//ʾ
	VK1640_Stop();
}

/*******************************************************************************
* Function Name  : VK1640_Disp_FixedAddr
* Description    : õ̶ַʽַ
* Input          : addr        
* Input          : data8       
* Output         : None
* Return         : None
*******************************************************************************/
void VK1640_Disp_FixedAddr(unsigned char addr, unsigned char data8)
{
	VK1640_Start();
	VK1640Write1BytetoIC(VK1640_WRDTA_FIXEDADDR);//òù̶ַдʾݣ
	VK1640_Stop();
	VK1640_Start();	
	VK1640Write1BytetoIC(VK1640_STARTADDR+addr);//ʾݶӦĵַ
	VK1640Write1BytetoIC(data8);//1BYTEʾ
	VK1640_Stop();
	VK1640_Start();	
	VK1640Write1BytetoIC(VK1640_DISP_ON|VK1640_PDUTY_12_16);//ʾ
	VK1640_Stop();
}
	
/*******************************************************************************
* Function Name  : Vk1640_Init
* Description    : 1640ʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/ 
void VK1640_Init(void)    
{   
	GPIO_SetMode(VK1640_CLK_PORT, VK1640_CLK_PIN, GPIO_MODE_OUTPUT);
	GPIO_SetMode(VK1640_DIO_PORT, VK1640_DIO_PIN, GPIO_MODE_OUTPUT);
	
	VK1640_DAT_HIGH;                
	VK1640_SLK_HIGH; 
}  

/*******************************************************************************
* Function Name  : VK1640_Main
* Description    : 1640Գ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/ 
void VK1640_Main(void)
{   
	unsigned char i,j;
	
	VK1640_Init();
	 
	for(i=0;i<16;i++)
	{
		vk1640_write_buf[i]=0x00;
	}
	VK1640_Disp_AutoAdd1Addr(0,vk1640_write_buf,16);   //16ȫ
	VK1640_delay_nms(1000); 
	while(1)
	{
		for(i=0;i<16;i++)
		{
			vk1640_write_buf[i]=0xff;
		}
		VK1640_Disp_AutoAdd1Addr(0,vk1640_write_buf,16);   //16ȫ
		VK1640_delay_nms(1000); 
		for(i=0;i<16;i++)
		{
			vk1640_write_buf[i]=0x00;
		}
		VK1640_Disp_AutoAdd1Addr(0,vk1640_write_buf,16);   //ȫ
		VK1640_delay_nms(1000); 
		
		for(j=0;j<16;j++)
		{
			for(i=0;i<16;i++)
			{
				vk1640_write_buf[i]=0x00;
			}
			vk1640_write_buf[j]=0xff;
			VK1640_Disp_AutoAdd1Addr(0,vk1640_write_buf,16);   //ȫ
			VK1640_delay_nms(500); 
		}
		for(j=0;j<8;j++)
		{
			for(i=0;i<16;i++)
			{
				vk1640_write_buf[i]=(1<<j);
			}
			VK1640_Disp_AutoAdd1Addr(0,vk1640_write_buf,16);   //ȫ
			VK1640_delay_nms(1000); 
		}
		
		__nop();
	}
}    
/************************END OF FILE****/
